package es.us.dit.ejemplo.pictionary;

public class Message {
    
    private String text;
    private String user;
    private boolean updateList;
    
    private String color;
    
    // only for initial messages
    private String keyword;
    private boolean startMessage;
    
    // only for end messages
    private boolean endMessage;
    
    // disconnect message
    private boolean disconnect;
    
    // restart message
    private boolean restart;
    
    // change painter, no winners
    private boolean changePainter;
    
    // wait for next game, no winners (general)
    private boolean waitNextGameNoWinners;
 
    public Message() {
    }
 
    public Message(String text) {
        this.text = text;
    }
     
    public Message(String text, boolean updateList) {
        this.text = text;
        this.updateList = updateList;
    }
 
    public Message(String user, String text, boolean updateList) {
        this.text = text;
        this.user = user;
        this.updateList = updateList;
    }
    
    // format for initial message with keyword
    public Message(String user, String text, boolean updateList, String keyword, boolean startMessage) {
        this.text = text;
        this.user = user;
        this.updateList = updateList;
        this.keyword = keyword;
        this.startMessage = startMessage;
    }
    
    // format for end message
    public Message(boolean endMessage, String user,boolean updateList) {
        this.user = user;
        this.endMessage = endMessage;
        this.updateList = updateList;
    }
    
    // format for disconnection message
    public Message(boolean disconnect, String user, String text, boolean updateList) {
        this.user = user;
        this.disconnect = disconnect;
        this.text = text;
        this.updateList = updateList;
    }
    
    // format for restart game with winner
    public Message(String user, boolean restart, String text, boolean updateList) {
    	this.user = user;
        this.restart = restart;
        this.text = text;
        this.updateList = updateList;
    }
    
    // format to change painter without winner
    public Message(boolean changePainter, boolean updateList, boolean restart) {
    	this.changePainter = changePainter;
    	this.updateList = updateList;
    	this.restart = restart;
    }
    
    // format to wait next game without winner 
    public Message(boolean updateList, boolean waitNextGameNoWinners) {
    	this.updateList = updateList;
    	this.waitNextGameNoWinners = waitNextGameNoWinners;
    }
    
    public String getText() {
        return text;
    }
 
    public Message setText(String text) {
        this.text = text;
        return this;
    }
 
    public String getUser() {
        return user;
    }
 
    public Message setUser(String user) {
        this.user = user;
        return this;
    }
 
    public boolean isUpdateList() {
        return updateList;
    }
 
    public void setUpdateList(boolean updateList) {
        this.updateList = updateList;
    }
    
    public String getKeyword() {
        return keyword;
    }
 
    public void setKeyword(String keyword) {
        this.keyword = keyword;
    }
    
    public boolean isStartMessage() {
        return startMessage;
    }
 
    public void setStartMessage(boolean startMessage) {
        this.startMessage = startMessage;
    }
    
    public boolean isEndMessage() {
        return endMessage;
    }
 
    public void setEndMessage(boolean endMessage) {
        this.endMessage = endMessage;
    }

	public boolean isDisconnect() {
		return disconnect;
	}

	public void setDisconnect(boolean disconnect) {
		this.disconnect = disconnect;
	}

	public boolean isRestart() {
		return restart;
	}

	public void setRestart(boolean restart) {
		this.restart = restart;
	}

	public String getColor() {
		return color;
	}

	public Message setColor(String color) {
		this.color = color;
		return this;
	}

	public boolean isChangePainter() {
		return changePainter;
	}

	public void setChangePainter(boolean changePainter) {
		this.changePainter = changePainter;
	}

	public boolean isWaitNextGameNoWinners() {
		return waitNextGameNoWinners;
	}

	public void setWaitNextGameNoWinners(boolean waitNextGameNoWinners) {
		this.waitNextGameNoWinners = waitNextGameNoWinners;
	}
}