package es.us.dit.ejemplo.pictionary;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
 
@ManagedBean
@ApplicationScoped
public class PictionaryUsers implements Serializable {
     
    private List<String> users;
     
    @PostConstruct
    public void init() {
        users = new ArrayList<String>();
    }
 
    public List<String> getUsers() {
        return users;
    }
     
    public void remove(String user) {
        this.users.remove(user);
    }
     
    public void add(String user) {
        this.users.add(user);
    }
         
    public boolean contains(String user) {
        return this.users.contains(user);
    }
    
    public boolean onlyOnePerson() {

    	boolean empty = true;
    	
    	if (this.users.size() <= 1)
    		empty=true;
    	else
    		empty=false;
    	
    	return empty;
    }
    
    public int size() {
    	return this.users.size();
    }
    
    public String getUser(int i){
    	return this.users.get(i);
    }
    
    public int getPositionOfUser(String user) {
    	return users.indexOf(user);
    }
    
    public String getNextUser(String user) {
    	String nextUser;
    	
    	if (users.indexOf(user) == (users.size() - 1) ) {
    		nextUser = users.get(0);
    	} else {
    		int actualPosition = this.users.indexOf(user);
    		nextUser = users.get(actualPosition + 1);
    	}
    	return nextUser;	
    }
}